"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const options_keys_1 = require("../../model/options.keys");
const main_1 = require("@angular/compiler-cli/src/main");
const logger_1 = require("../services/logger");
const gulp = require('gulp');
/**
 * Compile our typescript files with ngc
 */
class NgcCompileTask {
    /**
     * Registring the task
     */
    registerTask(argv, onError, dependencies = []) {
        const taskName = 'compile-ngc';
        const ngcArguments = { p: `${argv[options_keys_1.OptionsKeys.OUT_DIR]}/tsconfig-ngc.json` };
        logger_1.Logger.warning("\niniciando : " + taskName);
        gulp.task(taskName, dependencies, (done) => {
            main_1.main(ngcArguments, logger_1.Logger.error).then((exitCode) => {
                if (exitCode === 0) {
                    done();
                    logger_1.Logger.success("\ncompilados...");
                }
                else {
                    onError();
                    logger_1.Logger.error("\nerro na compilação (: ...");
                }
            });
        });
        logger_1.Logger.warning("finalizando : " + taskName);
        return taskName;
    }
}
exports.NgcCompileTask = NgcCompileTask;
//# sourceMappingURL=ngc-compile.task.js.map